---
image: python

stages:
  - test
  - build
  - release

before_script:
  - apt update
  - env DEBIAN_FRONTEND=noninteractive apt install --yes slapd python3-dev libldap2-dev libsasl2-dev libssl-dev ldap-utils
  - curl -O https://bootstrap.pypa.io/get-pip.py
  - python get-pip.py
  - pip install --upgrade tox "poetry>1.3.0" coveralls pyyaml tomli

style:
  image: python:3.11
  stage: test
  script: tox -e style

python37:
  image: python:3.7
  stage: test
  script: tox -e py37

python38:
  image: python:3.8
  stage: test
  script: tox -e py38

python39:
  image: python:3.9
  stage: test
  script: tox -e py39

python310:
  image: python:3.10
  stage: test
  script: tox -e py310

python311:
  image: python:3.11
  stage: test
  script: tox -e py311

doc:
  image: python:3.11
  stage: test
  script: tox -e doc

coverage:
  image: python:3.11
  stage: test
  allow_failure: true
  script:
    - tox -e coverage
    - coveralls
